package middleware

import (
	"net/http"

	"git.kirsle.net/apps/gosocial/pkg/log"
	"git.kirsle.net/apps/gosocial/pkg/session"
	"git.kirsle.net/apps/gosocial/pkg/templates"
)

// LoginRequired middleware.
func LoginRequired(handler http.Handler) http.Handler {
	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {

		// User must be logged in.
		if _, err := session.CurrentUser(r); err != nil {
			log.Error("LoginRequired: %s", err)
			errhandler := templates.MakeErrorPage("Login Required", "You must be signed in to view this page.", http.StatusForbidden)
			errhandler.ServeHTTP(w, r)
			return
		}

		handler.ServeHTTP(w, r)
	})
}
